Index: sys/netinet6/in6.c
===================================================================
--- sys/netinet6/in6.c	(revision 195689)
+++ sys/netinet6/in6.c	(working copy)
@@ -103,7 +103,6 @@
 #include <netinet6/in6_ifattach.h>
 #include <netinet6/scope6_var.h>
 #include <netinet6/in6_pcb.h>
-#include <netinet6/vinet6.h>
 
 /*
  * Definitions of some costant IP6 addresses.
@@ -181,7 +180,6 @@
 in6_control(struct socket *so, u_long cmd, caddr_t data,
     struct ifnet *ifp, struct thread *td)
 {
-	INIT_VNET_INET6(curvnet);
 	struct	in6_ifreq *ifr = (struct in6_ifreq *)data;
 	struct	in6_ifaddr *ia = NULL;
 	struct	in6_aliasreq *ifra = (struct in6_aliasreq *)data;
@@ -682,7 +680,6 @@
 in6_update_ifa(struct ifnet *ifp, struct in6_aliasreq *ifra,
     struct in6_ifaddr *ia, int flags)
 {
-	INIT_VNET_INET6(ifp->if_vnet);
 	int error = 0, hostIsNew = 0, plen = -1;
 	struct sockaddr_in6 dst6;
 	struct in6_addrlifetime *lt;
@@ -1388,7 +1385,6 @@
 static void
 in6_unlink_ifa(struct in6_ifaddr *ia, struct ifnet *ifp)
 {
-	INIT_VNET_INET6(ifp->if_vnet);
 	int	s = splnet();
 
 	IF_ADDR_LOCK(ifp);
@@ -1964,7 +1960,6 @@
 int
 in6_localaddr(struct in6_addr *in6)
 {
-	INIT_VNET_INET6(curvnet);
 	struct in6_ifaddr *ia;
 
 	if (IN6_IS_ADDR_LOOPBACK(in6) || IN6_IS_ADDR_LINKLOCAL(in6))
@@ -1986,7 +1981,6 @@
 int
 in6_is_addr_deprecated(struct sockaddr_in6 *sa6)
 {
-	INIT_VNET_INET6(curvnet);
 	struct in6_ifaddr *ia;
 
 	IN6_IFADDR_RLOCK();
@@ -2083,7 +2077,6 @@
 struct in6_ifaddr *
 in6_ifawithifp(struct ifnet *ifp, struct in6_addr *dst)
 {
-	INIT_VNET_INET6(curvnet);
 	int dst_scope =	in6_addrscope(dst), blen = -1, tlen;
 	struct ifaddr *ifa;
 	struct in6_ifaddr *besta = 0;
@@ -2244,8 +2237,6 @@
 void
 in6_setmaxmtu(void)
 {
-	INIT_VNET_NET(curvnet);
-	INIT_VNET_INET6(curvnet);
 	unsigned long maxmtu = 0;
 	struct ifnet *ifp;
 
Index: sys/netinet6/nd6.h
===================================================================
--- sys/netinet6/nd6.h	(revision 195689)
+++ sys/netinet6/nd6.h	(working copy)
@@ -318,29 +318,45 @@
 LIST_HEAD(nd_prhead, nd_prefix);
 
 /* nd6.c */
-#ifdef VIMAGE_GLOBALS
-extern int nd6_prune;
-extern int nd6_delay;
-extern int nd6_umaxtries;
-extern int nd6_mmaxtries;
-extern int nd6_useloopback;
-extern int nd6_maxnudhint;
-extern int nd6_gctimer;
-extern struct nd_drhead nd_defrouter;
-extern struct nd_prhead nd_prefix;
-extern int nd6_debug;
-extern int nd6_onlink_ns_rfc4861;
+VNET_DECLARE(int, nd6_prune);
+VNET_DECLARE(int, nd6_delay);
+VNET_DECLARE(int, nd6_umaxtries);
+VNET_DECLARE(int, nd6_mmaxtries);
+VNET_DECLARE(int, nd6_useloopback);
+VNET_DECLARE(int, nd6_maxnudhint);
+VNET_DECLARE(int, nd6_gctimer);
+VNET_DECLARE(struct nd_drhead, nd_defrouter);
+VNET_DECLARE(struct nd_prhead, nd_prefix);
+VNET_DECLARE(int, nd6_debug);
+VNET_DECLARE(int, nd6_onlink_ns_rfc4861);
+VNET_DECLARE(struct callout, nd6_timer_ch);
 
-extern struct callout nd6_timer_ch;
+#define	V_nd6_prune			VNET_GET(nd6_prune)
+#define	V_nd6_delay			VNET_GET(nd6_delay)
+#define	V_nd6_umaxtries			VNET_GET(nd6_umaxtries)
+#define	V_nd6_mmaxtries			VNET_GET(nd6_mmaxtries)
+#define	V_nd6_useloopback		VNET_GET(nd6_useloopback)
+#define	V_nd6_maxnudhint		VNET_GET(nd6_maxnudhint)
+#define	V_nd6_gctimer			VNET_GET(nd6_gctimer)
+#define	V_nd_defrouter			VNET_GET(nd_defrouter)
+#define	V_nd_prefix			VNET_GET(nd_prefix)
+#define	V_nd6_debug			VNET_GET(nd6_debug)
+#define	V_nd6_onlink_ns_rfc4861		VNET_GET(nd6_onlink_ns_rfc4861)
+#define	V_nd6_timer_ch			VNET_GET(nd6_timer_ch)
 
 /* nd6_rtr.c */
-extern int nd6_defifindex;
-extern int ip6_desync_factor;	/* seconds */
-extern u_int32_t ip6_temp_preferred_lifetime; /* seconds */
-extern u_int32_t ip6_temp_valid_lifetime; /* seconds */
-extern int ip6_temp_regen_advance; /* seconds */
-#endif /* VIMAGE_GLOBALS */
+VNET_DECLARE(int, nd6_defifindex);
+VNET_DECLARE(int, ip6_desync_factor);	/* seconds */
+VNET_DECLARE(u_int32_t, ip6_temp_preferred_lifetime); /* seconds */
+VNET_DECLARE(u_int32_t, ip6_temp_valid_lifetime); /* seconds */
+VNET_DECLARE(int, ip6_temp_regen_advance); /* seconds */
 
+#define	V_nd6_defifindex		VNET_GET(nd6_defifindex)
+#define	V_ip6_desync_factor		VNET_GET(ip6_desync_factor)
+#define	V_ip6_temp_preferred_lifetime	VNET_GET(ip6_temp_preferred_lifetime)
+#define	V_ip6_temp_valid_lifetime	VNET_GET(ip6_temp_valid_lifetime)
+#define	V_ip6_temp_regen_advance	VNET_GET(ip6_temp_regen_advance)
+
 #define nd6log(x)	do { if (V_nd6_debug) log x; } while (/*CONSTCOND*/ 0)
 
 union nd_opts {
Index: sys/netinet6/mld6.c
===================================================================
--- sys/netinet6/mld6.c	(revision 195689)
+++ sys/netinet6/mld6.c	(working copy)
@@ -94,8 +94,6 @@
 #include <netinet/icmp6.h>
 #include <netinet6/mld6.h>
 #include <netinet6/mld6_var.h>
-#include <netinet/vinet.h>
-#include <netinet6/vinet6.h>
 
 #include <security/mac/mac_framework.h>
 
@@ -207,14 +205,18 @@
 /*
  * VIMAGE-wide globals.
  */
-#ifdef VIMAGE_GLOBALS
-struct timeval			 mld_gsrdelay;
-LIST_HEAD(, mld_ifinfo)		 mli_head;
-int				 interface_timers_running6;
-int				 state_change_timers_running6;
-int				 current_state_timers_running6;
-#endif /* VIMAGE_GLOBALS */
+static VNET_DEFINE(struct timeval, mld_gsrdelay) = {10, 0};
+static VNET_DEFINE(LIST_HEAD(, mld_ifinfo), mli_head);
+static VNET_DEFINE(int, interface_timers_running6);
+static VNET_DEFINE(int, state_change_timers_running6);
+static VNET_DEFINE(int, current_state_timers_running6);
 
+#define	V_mld_gsrdelay			VNET_GET(mld_gsrdelay)
+#define	V_mli_head			VNET_GET(mli_head)
+#define	V_interface_timers_running6	VNET_GET(interface_timers_running6)
+#define	V_state_change_timers_running6	VNET_GET(state_change_timers_running6)
+#define	V_current_state_timers_running6	VNET_GET(current_state_timers_running6)
+
 SYSCTL_DECL(_net_inet6);	/* Note: Not in any common header. */
 
 SYSCTL_NODE(_net_inet6, OID_AUTO, mld, CTLFLAG_RW, 0,
@@ -223,9 +225,9 @@
 /*
  * Virtualized sysctls.
  */
-SYSCTL_V_PROC(V_NET, vnet_inet6, _net_inet6_mld, OID_AUTO, gsrdelay,
-    CTLTYPE_INT | CTLFLAG_RW | CTLFLAG_MPSAFE, mld_gsrdelay.tv_sec, 0,
-    sysctl_mld_gsr, "I",
+SYSCTL_VNET_PROC(_net_inet6_mld, OID_AUTO, gsrdelay,
+    CTLTYPE_INT | CTLFLAG_RW | CTLFLAG_MPSAFE,
+    &VNET_NAME(mld_gsrdelay.tv_sec), 0, sysctl_mld_gsr, "I",
     "Rate limit for MLDv2 Group-and-Source queries in seconds");
 
 /*
@@ -308,7 +310,6 @@
 static int
 sysctl_mld_gsr(SYSCTL_HANDLER_ARGS)
 {
-	INIT_VNET_INET6(curvnet);
 	int error;
 	int i;
 
@@ -349,8 +350,6 @@
 static int
 sysctl_mld_ifinfo(SYSCTL_HANDLER_ARGS)
 {
-	INIT_VNET_NET(curvnet);
-	INIT_VNET_INET6(curvnet);
 	int			*name;
 	int			 error;
 	u_int			 namelen;
@@ -479,7 +478,6 @@
 static struct mld_ifinfo *
 mli_alloc_locked(/*const*/ struct ifnet *ifp)
 {
-	INIT_VNET_INET6(ifp->if_vnet);
 	struct mld_ifinfo *mli;
 
 	MLD_LOCK_ASSERT();
@@ -582,7 +580,6 @@
 static void
 mli_delete_locked(const struct ifnet *ifp)
 {
-	INIT_VNET_INET6(ifp->if_vnet);
 	struct mld_ifinfo *mli, *tmli;
 
 	CTR3(KTR_MLD, "%s: freeing mld_ifinfo for ifp %p(%s)",
@@ -747,7 +744,6 @@
 static void
 mld_v1_update_group(struct in6_multi *inm, const int timer)
 {
-	INIT_VNET_INET6(curvnet);
 #ifdef KTR
 	char			 ip6tbuf[INET6_ADDRSTRLEN];
 #endif
@@ -801,7 +797,6 @@
 mld_v2_input_query(struct ifnet *ifp, const struct ip6_hdr *ip6,
     struct mbuf *m, const int off, const int icmp6len)
 {
-	INIT_VNET_INET6(curvnet);
 	struct mld_ifinfo	*mli;
 	struct mldv2_query	*mld;
 	struct in6_multi	*inm;
@@ -980,7 +975,6 @@
 mld_v2_process_group_query(struct in6_multi *inm, struct mld_ifinfo *mli,
     int timer, struct mbuf *m0, const int off)
 {
-	INIT_VNET_INET6(curvnet);
 	struct mldv2_query	*mld;
 	int			 retval;
 	uint16_t		 nsrc;
@@ -1252,7 +1246,6 @@
 	CTR3(KTR_MLD, "%s: called w/mbuf (%p,%d)", __func__, m, off);
 
 	ifp = m->m_pkthdr.rcvif;
-	INIT_VNET_INET6(ifp->if_vnet);
 
 	ip6 = mtod(m, struct ip6_hdr *);
 
@@ -1330,7 +1323,6 @@
 static void
 mld_fasttimo_vnet(void)
 {
-	INIT_VNET_INET6(curvnet);
 	struct ifqueue		 scq;	/* State-change packets */
 	struct ifqueue		 qrq;	/* Query response packets */
 	struct ifnet		*ifp;
@@ -1458,7 +1450,6 @@
 static void
 mld_v1_process_group_timer(struct in6_multi *inm, const int version)
 {
-	INIT_VNET_INET6(curvnet);
 	int report_timer_expired;
 
 	IN6_MULTI_LOCK_ASSERT();
@@ -1505,7 +1496,6 @@
     struct ifqueue *qrq, struct ifqueue *scq,
     struct in6_multi *inm, const int uri_fasthz)
 {
-	INIT_VNET_INET6(curvnet);
 	int query_response_timer_expired;
 	int state_change_retransmit_timer_expired;
 #ifdef KTR
@@ -1654,7 +1644,6 @@
 static void
 mld_v2_cancel_link_timers(struct mld_ifinfo *mli)
 {
-	INIT_VNET_INET6(curvnet);
 	struct ifmultiaddr	*ifma;
 	struct ifnet		*ifp;
 	struct in6_multi		*inm;
@@ -1747,7 +1736,6 @@
 static void
 mld_slowtimo_vnet(void)
 {
-	INIT_VNET_INET6(curvnet);
 	struct mld_ifinfo *mli;
 
 	MLD_LOCK();
@@ -1951,7 +1939,6 @@
 mld_initial_join(struct in6_multi *inm, struct mld_ifinfo *mli,
     const int delay)
 {
-	INIT_VNET_INET6(curvnet);
 	struct ifnet		*ifp;
 	struct ifqueue		*ifq;
 	int			 error, retval, syncstates;
@@ -2100,7 +2087,6 @@
 static int
 mld_handle_state_change(struct in6_multi *inm, struct mld_ifinfo *mli)
 {
-	INIT_VNET_INET6(curvnet);
 	struct ifnet		*ifp;
 	int			 retval;
 #ifdef KTR
@@ -2164,7 +2150,6 @@
 static void
 mld_final_leave(struct in6_multi *inm, struct mld_ifinfo *mli)
 {
-	INIT_VNET_INET6(curvnet);
 	int syncstates;
 #ifdef KTR
 	char ip6tbuf[INET6_ADDRSTRLEN];
@@ -2947,7 +2932,6 @@
 static void
 mld_v2_dispatch_general_query(struct mld_ifinfo *mli)
 {
-	INIT_VNET_INET6(curvnet);
 	struct ifmultiaddr	*ifma, *tifma;
 	struct ifnet		*ifp;
 	struct in6_multi	*inm;
@@ -3036,8 +3020,6 @@
 	 * indexes to guard against interface detach, they are
 	 * unique to each VIMAGE and must be retrieved.
 	 */
-	INIT_VNET_NET(curvnet);
-	INIT_VNET_INET6(curvnet);
 	ifindex = mld_restore_context(m);
 
 	/*
@@ -3247,31 +3229,17 @@
 static int
 vnet_mld_iattach(const void *unused __unused)
 {
-	INIT_VNET_INET6(curvnet);
 
 	CTR1(KTR_MLD, "%s: initializing", __func__);
 
 	LIST_INIT(&V_mli_head);
 
-	V_current_state_timers_running6 = 0;
-	V_interface_timers_running6 = 0;
-	V_state_change_timers_running6 = 0;
-
-	/*
-	 * Initialize sysctls to default values.
-	 */
-	V_mld_gsrdelay.tv_sec = 10;
-	V_mld_gsrdelay.tv_usec = 0;
-
 	return (0);
 }
 
 static int
 vnet_mld_idetach(const void *unused __unused)
 {
-#ifdef INVARIANTS
-	INIT_VNET_INET6(curvnet);
-#endif
 
 	CTR1(KTR_MLD, "%s: tearing down", __func__);
 
@@ -3281,7 +3249,7 @@
 	return (0);
 }
 
-#ifndef VIMAGE_GLOBALS
+#ifdef VIMAGE
 static vnet_modinfo_t vnet_mld_modinfo = {
 	.vmi_id		= VNET_MOD_MLD,
 	.vmi_name	= "mld",
@@ -3298,14 +3266,14 @@
     switch (type) {
     case MOD_LOAD:
 	mld_sysinit();
-#ifndef VIMAGE_GLOBALS
+#ifdef VIMAGE
 	vnet_mod_register(&vnet_mld_modinfo);
 #else
 	vnet_mld_iattach(NULL);
 #endif
 	break;
     case MOD_UNLOAD:
-#ifndef VIMAGE_GLOBALS
+#ifdef VIMAGE
 	vnet_mod_deregister(&vnet_mld_modinfo);
 #else
 	vnet_mld_idetach(NULL);
Index: sys/netinet6/in6_src.c
===================================================================
--- sys/netinet6/in6_src.c	(revision 195689)
+++ sys/netinet6/in6_src.c	(working copy)
@@ -100,7 +100,6 @@
 #include <netinet/ip_var.h>
 #include <netinet/udp.h>
 #include <netinet/udp_var.h>
-#include <netinet/vinet.h>
 
 #include <netinet6/in6_var.h>
 #include <netinet/ip6.h>
@@ -108,7 +107,6 @@
 #include <netinet6/ip6_var.h>
 #include <netinet6/scope6_var.h>
 #include <netinet6/nd6.h>
-#include <netinet6/vinet6.h>
 
 static struct mtx addrsel_lock;
 #define	ADDRSEL_LOCK_INIT()	mtx_init(&addrsel_lock, "addrsel_lock", NULL, MTX_DEF)
@@ -125,11 +123,11 @@
 
 #define ADDR_LABEL_NOTAPP (-1)
 
-#ifdef VIMAGE_GLOBALS
-struct in6_addrpolicy defaultaddrpolicy;
-int ip6_prefer_tempaddr;
-#endif
+static VNET_DEFINE(struct in6_addrpolicy, defaultaddrpolicy);
+VNET_DEFINE(int, ip6_prefer_tempaddr);
 
+#define	V_defaultaddrpolicy		VNET_GET(defaultaddrpolicy)
+
 static int selectroute __P((struct sockaddr_in6 *, struct ip6_pktopts *,
 	struct ip6_moptions *, struct route_in6 *, struct ifnet **,
 	struct rtentry **, int));
@@ -184,7 +182,6 @@
     struct inpcb *inp, struct route_in6 *ro, struct ucred *cred,
     struct ifnet **ifpp, struct in6_addr *srcp)
 {
-	INIT_VNET_INET6(curvnet);
 	struct in6_addr dst;
 	struct ifnet *ifp = NULL;
 	struct in6_ifaddr *ia = NULL, *ia_best = NULL;
@@ -488,7 +485,6 @@
     struct ip6_moptions *mopts, struct route_in6 *ro,
     struct ifnet **retifp, struct rtentry **retrt, int norouteok)
 {
-	INIT_VNET_INET6(curvnet);
 	int error = 0;
 	struct ifnet *ifp = NULL;
 	struct rtentry *rt = NULL;
@@ -793,7 +789,6 @@
 int
 in6_selecthlim(struct inpcb *in6p, struct ifnet *ifp)
 {
-	INIT_VNET_INET6(curvnet);
 
 	if (in6p && in6p->in6p_hops >= 0)
 		return (in6p->in6p_hops);
@@ -826,7 +821,6 @@
 int
 in6_pcbsetport(struct in6_addr *laddr, struct inpcb *inp, struct ucred *cred)
 {
-	INIT_VNET_INET(curvnet);
 	struct socket *so = inp->inp_socket;
 	u_int16_t lport = 0, first, last, *lastport;
 	int count, error, wild = 0, dorandom;
@@ -928,7 +922,6 @@
 void
 addrsel_policy_init(void)
 {
-	INIT_VNET_INET6(curvnet);
 
 	V_ip6_prefer_tempaddr = 0;
 
@@ -948,7 +941,6 @@
 static struct in6_addrpolicy *
 lookup_addrsel_policy(struct sockaddr_in6 *key)
 {
-	INIT_VNET_INET6(curvnet);
 	struct in6_addrpolicy *match = NULL;
 
 	ADDRSEL_LOCK();
@@ -1035,14 +1027,12 @@
 
 TAILQ_HEAD(addrsel_policyhead, addrsel_policyent);
 
-#ifdef VIMAGE_GLOBALS
-struct addrsel_policyhead addrsel_policytab;
-#endif
+static VNET_DEFINE(struct addrsel_policyhead, addrsel_policytab);
+#define	V_addrsel_policytab		VNET_GET(addrsel_policytab)
 
 static void
 init_policy_queue(void)
 {
-	INIT_VNET_INET6(curvnet);
 
 	TAILQ_INIT(&V_addrsel_policytab);
 }
@@ -1050,7 +1040,6 @@
 static int
 add_addrsel_policyent(struct in6_addrpolicy *newpolicy)
 {
-	INIT_VNET_INET6(curvnet);
 	struct addrsel_policyent *new, *pol;
 
 	new = malloc(sizeof(*new), M_IFADDR,
@@ -1086,7 +1075,6 @@
 static int
 delete_addrsel_policyent(struct in6_addrpolicy *key)
 {
-	INIT_VNET_INET6(curvnet);
 	struct addrsel_policyent *pol;
 
 	ADDRSEL_XLOCK();
@@ -1118,7 +1106,6 @@
 walk_addrsel_policy(int (*callback)(struct in6_addrpolicy *, void *),
     void *w)
 {
-	INIT_VNET_INET6(curvnet);
 	struct addrsel_policyent *pol;
 	int error = 0;
 
@@ -1147,7 +1134,6 @@
 static struct in6_addrpolicy *
 match_addrsel_policy(struct sockaddr_in6 *key)
 {
-	INIT_VNET_INET6(curvnet);
 	struct addrsel_policyent *pent;
 	struct in6_addrpolicy *bestpol = NULL, *pol;
 	int matchlen, bestmatchlen = -1;
Index: sys/netinet6/ip6_input.c
===================================================================
--- sys/netinet6/ip6_input.c	(revision 195689)
+++ sys/netinet6/ip6_input.c	(working copy)
@@ -96,7 +96,6 @@
 #ifdef INET
 #include <netinet/ip.h>
 #include <netinet/ip_icmp.h>
-#include <netinet/vinet.h>
 #endif /* INET */
 #include <netinet/ip6.h>
 #include <netinet6/in6_var.h>
@@ -106,7 +105,6 @@
 #include <netinet6/scope6_var.h>
 #include <netinet6/in6_ifattach.h>
 #include <netinet6/nd6.h>
-#include <netinet6/vinet6.h>
 
 #ifdef IPSEC
 #include <netipsec/ipsec.h>
@@ -127,29 +125,31 @@
 	.nh_policy = NETISR_POLICY_FLOW,
 };
 
-#ifndef VIMAGE
-#ifndef VIMAGE_GLOBALS
-struct vnet_inet6 vnet_inet6_0;
-#endif
-#endif
+VNET_DEFINE(struct in6_ifaddrhead, in6_ifaddrhead);
+VNET_DEFINE(struct ip6stat, ip6stat);
 
-#ifdef VIMAGE_GLOBALS
-struct in6_ifaddrhead in6_ifaddrhead;
-struct ip6stat ip6stat;
+VNET_DECLARE(struct callout, in6_tmpaddrtimer_ch);
+VNET_DECLARE(int, dad_init);
+VNET_DECLARE(int, pmtu_expire);
+VNET_DECLARE(int, pmtu_probe);
+VNET_DECLARE(u_long, rip6_sendspace);
+VNET_DECLARE(u_long, rip6_recvspace);
+VNET_DECLARE(int, icmp6errppslim);
+VNET_DECLARE(int, icmp6_nodeinfo);
+VNET_DECLARE(int, udp6_sendspace);
+VNET_DECLARE(int, udp6_recvspace);
 
-extern struct callout in6_tmpaddrtimer_ch;
+#define	V_in6_tmpaddrtimer_ch		VNET_GET(in6_tmpaddrtimer_ch)
+#define	V_dad_init			VNET_GET(dad_init)
+#define	V_pmtu_expire			VNET_GET(pmtu_expire)
+#define	V_pmtu_probe			VNET_GET(pmtu_probe)
+#define	V_rip6_sendspace		VNET_GET(rip6_sendspace)
+#define	V_rip6_recvspace		VNET_GET(rip6_recvspace)
+#define	V_icmp6errppslim		VNET_GET(icmp6errppslim)
+#define	V_icmp6_nodeinfo		VNET_GET(icmp6_nodeinfo)
+#define	V_udp6_sendspace		VNET_GET(udp6_sendspace)
+#define	V_udp6_recvspace		VNET_GET(udp6_recvspace)
 
-extern int dad_init;
-extern int pmtu_expire;
-extern int pmtu_probe;
-extern u_long rip6_sendspace;
-extern u_long rip6_recvspace;
-extern int icmp6errppslim;
-extern int icmp6_nodeinfo;
-extern int udp6_sendspace;
-extern int udp6_recvspace;
-#endif
-
 struct rwlock in6_ifaddr_lock;
 RW_SYSINIT(in6_ifaddr_lock, &in6_ifaddr_lock, "in6_ifaddr_lock");
 
@@ -162,13 +162,13 @@
 static struct mbuf *ip6_pullexthdr(struct mbuf *, size_t, int);
 #endif
 
-#ifndef VIMAGE_GLOBALS
+#ifdef VIMAGE
+/* XXX only has to stay for .vmi_dependson elsewhere. */
 static void vnet_inet6_register(void);
  
 static const vnet_modinfo_t vnet_inet6_modinfo = {
 	.vmi_id		= VNET_MOD_INET6,
 	.vmi_name	= "inet6",
-	.vmi_size	= sizeof(struct vnet_inet6),
 	.vmi_dependson	= VNET_MOD_INET	/* XXX revisit - TCP/UDP needs this? */
 };
  
@@ -189,7 +189,6 @@
 void
 ip6_init(void)
 {
-	INIT_VNET_INET6(curvnet);
 	struct ip6protosw *pr;
 	int i;
 
@@ -311,7 +310,6 @@
 void
 ip6_destroy()
 {
-	INIT_VNET_INET6(curvnet);
 
 	nd6_destroy();
 	callout_drain(&V_in6_tmpaddrtimer_ch);
@@ -321,7 +319,6 @@
 static int
 ip6_init2_vnet(const void *unused __unused)
 {
-	INIT_VNET_INET6(curvnet);
 
 	/* nd6_timer_init */
 	callout_init(&V_nd6_timer_ch, 0);
@@ -351,8 +348,6 @@
 void
 ip6_input(struct mbuf *m)
 {
-	INIT_VNET_NET(curvnet);
-	INIT_VNET_INET6(curvnet);
 	struct ip6_hdr *ip6;
 	int off = sizeof(struct ip6_hdr), nest;
 	u_int32_t plen;
@@ -967,7 +962,6 @@
 ip6_hopopts_input(u_int32_t *plenp, u_int32_t *rtalertp,
     struct mbuf **mp, int *offp)
 {
-	INIT_VNET_INET6(curvnet);
 	struct mbuf *m = *mp;
 	int off = *offp, hbhlen;
 	struct ip6_hbh *hbh;
@@ -1023,7 +1017,6 @@
 ip6_process_hopopts(struct mbuf *m, u_int8_t *opthead, int hbhlen,
     u_int32_t *rtalertp, u_int32_t *plenp)
 {
-	INIT_VNET_INET6(curvnet);
 	struct ip6_hdr *ip6;
 	int optlen = 0;
 	u_int8_t *opt = opthead;
@@ -1156,7 +1149,6 @@
 int
 ip6_unknown_opt(u_int8_t *optp, struct mbuf *m, int off)
 {
-	INIT_VNET_INET6(curvnet);
 	struct ip6_hdr *ip6;
 
 	switch (IP6OPT_TYPE(*optp)) {
Index: sys/netinet6/nd6_rtr.c
===================================================================
--- sys/netinet6/nd6_rtr.c	(revision 195689)
+++ sys/netinet6/nd6_rtr.c	(working copy)
@@ -66,7 +66,6 @@
 #include <netinet6/nd6.h>
 #include <netinet/icmp6.h>
 #include <netinet6/scope6_var.h>
-#include <netinet6/vinet6.h>
 
 static int rtpref(struct nd_defrouter *);
 static struct nd_defrouter *defrtrlist_update(struct nd_defrouter *);
@@ -88,18 +87,18 @@
 
 static int rt6_deleteroute(struct radix_node *, void *);
 
-#ifdef VIMAGE_GLOBALS
-extern int nd6_recalc_reachtm_interval;
+VNET_DECLARE(int, nd6_recalc_reachtm_interval);
+#define	V_nd6_recalc_reachtm_interval	VNET_GET(nd6_recalc_reachtm_interval)
 
-static struct ifnet *nd6_defifp;
-int nd6_defifindex;
+static VNET_DEFINE(struct ifnet *, nd6_defifp);
+#define	V_nd6_defifp			VNET_GET(nd6_defifp)
 
-int ip6_use_tempaddr;
-int ip6_desync_factor;
-u_int32_t ip6_temp_preferred_lifetime;
-u_int32_t ip6_temp_valid_lifetime;
-int ip6_temp_regen_advance;
-#endif
+VNET_DEFINE(int, nd6_defifindex);
+VNET_DEFINE(int, ip6_use_tempaddr);
+VNET_DEFINE(int, ip6_desync_factor);
+VNET_DEFINE(u_int32_t, ip6_temp_preferred_lifetime);
+VNET_DEFINE(u_int32_t, ip6_temp_valid_lifetime);
+VNET_DEFINE(int, ip6_temp_regen_advance);
 
 /* RTPREF_MEDIUM has to be 0! */
 #define RTPREF_HIGH	1
@@ -118,7 +117,6 @@
 void
 nd6_rs_input(struct mbuf *m, int off, int icmp6len)
 {
-	INIT_VNET_INET6(curvnet);
 	struct ifnet *ifp = m->m_pkthdr.rcvif;
 	struct ip6_hdr *ip6 = mtod(m, struct ip6_hdr *);
 	struct nd_router_solicit *nd_rs;
@@ -203,7 +201,6 @@
 void
 nd6_ra_input(struct mbuf *m, int off, int icmp6len)
 {
-	INIT_VNET_INET6(curvnet);
 	struct ifnet *ifp = m->m_pkthdr.rcvif;
 	struct nd_ifinfo *ndi = ND_IFINFO(ifp);
 	struct ip6_hdr *ip6 = mtod(m, struct ip6_hdr *);
@@ -491,7 +488,6 @@
 struct nd_defrouter *
 defrouter_lookup(struct in6_addr *addr, struct ifnet *ifp)
 {
-	INIT_VNET_INET6(ifp->if_vnet);
 	struct nd_defrouter *dr;
 
 	for (dr = TAILQ_FIRST(&V_nd_defrouter); dr;
@@ -540,7 +536,6 @@
 void
 defrouter_reset(void)
 {
-	INIT_VNET_INET6(curvnet);
 	struct nd_defrouter *dr;
 
 	for (dr = TAILQ_FIRST(&V_nd_defrouter); dr;
@@ -556,7 +551,6 @@
 void
 defrtrlist_del(struct nd_defrouter *dr)
 {
-	INIT_VNET_INET6(curvnet);
 	struct nd_defrouter *deldr = NULL;
 	struct nd_prefix *pr;
 
@@ -618,7 +612,6 @@
 void
 defrouter_select(void)
 {
-	INIT_VNET_INET6(curvnet);
 	int s = splnet();
 	struct nd_defrouter *dr, *selected_dr = NULL, *installed_dr = NULL;
 	struct llentry *ln = NULL;
@@ -743,7 +736,6 @@
 static struct nd_defrouter *
 defrtrlist_update(struct nd_defrouter *new)
 {
-	INIT_VNET_INET6(curvnet);
 	struct nd_defrouter *dr, *n;
 	int s = splnet();
 
@@ -865,7 +857,6 @@
 struct nd_prefix *
 nd6_prefix_lookup(struct nd_prefixctl *key)
 {
-	INIT_VNET_INET6(curvnet);
 	struct nd_prefix *search;
 
 	for (search = V_nd_prefix.lh_first;
@@ -885,7 +876,6 @@
 nd6_prelist_add(struct nd_prefixctl *pr, struct nd_defrouter *dr,
     struct nd_prefix **newp)
 {
-	INIT_VNET_INET6(curvnet);
 	struct nd_prefix *new = NULL;
 	int error = 0;
 	int i, s;
@@ -944,7 +934,6 @@
 void
 prelist_remove(struct nd_prefix *pr)
 {
-	INIT_VNET_INET6(curvnet);
 	struct nd_pfxrouter *pfr, *next;
 	int e, s;
 	char ip6buf[INET6_ADDRSTRLEN];
@@ -997,7 +986,6 @@
 prelist_update(struct nd_prefixctl *new, struct nd_defrouter *dr,
     struct mbuf *m, int mcast)
 {
-	INIT_VNET_INET6(curvnet);
 	struct in6_ifaddr *ia6 = NULL, *ia6_match = NULL;
 	struct ifaddr *ifa;
 	struct ifnet *ifp = new->ndpr_ifp;
@@ -1374,7 +1362,6 @@
 void
 pfxlist_onlink_check()
 {
-	INIT_VNET_INET6(curvnet);
 	struct nd_prefix *pr;
 	struct in6_ifaddr *ifa;
 	struct nd_defrouter *dr;
@@ -1556,7 +1543,6 @@
 int
 nd6_prefix_onlink(struct nd_prefix *pr)
 {
-	INIT_VNET_INET6(curvnet);
 	struct ifaddr *ifa;
 	struct ifnet *ifp = pr->ndpr_ifp;
 	struct sockaddr_in6 mask6;
@@ -1682,7 +1668,6 @@
 int
 nd6_prefix_offlink(struct nd_prefix *pr)
 {
-	INIT_VNET_INET6(curvnet);
 	int error = 0;
 	struct ifnet *ifp = pr->ndpr_ifp;
 	struct nd_prefix *opr;
@@ -1774,7 +1759,6 @@
 static struct in6_ifaddr *
 in6_ifadd(struct nd_prefixctl *pr, int mcast)
 {
-	INIT_VNET_INET6(curvnet);
 	struct ifnet *ifp = pr->ndpr_ifp;
 	struct ifaddr *ifa;
 	struct in6_aliasreq ifra;
@@ -1912,7 +1896,6 @@
 int
 in6_tmpifadd(const struct in6_ifaddr *ia0, int forcegen, int delay)
 {
-	INIT_VNET_INET6(curvnet);
 	struct ifnet *ifp = ia0->ia_ifa.ifa_ifp;
 	struct in6_ifaddr *newia, *ia;
 	struct in6_aliasreq ifra;
@@ -2141,8 +2124,6 @@
 int
 nd6_setdefaultiface(int ifindex)
 {
-	INIT_VNET_NET(curvnet);
-	INIT_VNET_INET6(curvnet);
 	int error = 0;
 
 	if (ifindex < 0 || V_if_index < ifindex)
Index: sys/netinet6/in6_pcb.c
===================================================================
--- sys/netinet6/in6_pcb.c	(revision 195689)
+++ sys/netinet6/in6_pcb.c	(working copy)
@@ -95,14 +95,12 @@
 #include <netinet/tcp_var.h>
 #include <netinet/ip6.h>
 #include <netinet/ip_var.h>
-#include <netinet/vinet.h>
 
 #include <netinet6/ip6_var.h>
 #include <netinet6/nd6.h>
 #include <netinet/in_pcb.h>
 #include <netinet6/in6_pcb.h>
 #include <netinet6/scope6_var.h>
-#include <netinet6/vinet6.h>
 
 #include <security/mac/mac_framework.h>
 
@@ -112,8 +110,6 @@
 in6_pcbbind(register struct inpcb *inp, struct sockaddr *nam,
     struct ucred *cred)
 {
-	INIT_VNET_INET6(inp->inp_vnet);
-	INIT_VNET_INET(inp->inp_vnet);
 	struct socket *so = inp->inp_socket;
 	struct sockaddr_in6 *sin6 = (struct sockaddr_in6 *)NULL;
 	struct inpcbinfo *pcbinfo = inp->inp_pcbinfo;
@@ -291,7 +287,6 @@
 in6_pcbladdr(register struct inpcb *inp, struct sockaddr *nam,
     struct in6_addr *plocal_addr6)
 {
-	INIT_VNET_INET6(inp->inp_vnet);
 	register struct sockaddr_in6 *sin6 = (struct sockaddr_in6 *)nam;
 	int error = 0;
 	struct ifnet *ifp = NULL;
Index: sys/netinet6/in6_gif.c
===================================================================
--- sys/netinet6/in6_gif.c	(revision 195689)
+++ sys/netinet6/in6_gif.c	(working copy)
@@ -66,7 +66,6 @@
 #include <netinet/ip_ecn.h>
 #ifdef INET6
 #include <netinet6/ip6_ecn.h>
-#include <netinet6/vinet6.h>
 #endif
 
 #include <net/if_gif.h>
@@ -91,7 +90,6 @@
     int family,			/* family of the packet to be encapsulate */
     struct mbuf *m)
 {
-	INIT_VNET_GIF(ifp->if_vnet);
 	struct gif_softc *sc = ifp->if_softc;
 	struct sockaddr_in6 *dst = (struct sockaddr_in6 *)&sc->gif_ro6.ro_dst;
 	struct sockaddr_in6 *sin6_src = (struct sockaddr_in6 *)sc->gif_psrc;
@@ -279,7 +277,6 @@
 int
 in6_gif_input(struct mbuf **mp, int *offp, int proto)
 {
-	INIT_VNET_INET6(curvnet);
 	struct mbuf *m = *mp;
 	struct ifnet *gifp = NULL;
 	struct gif_softc *sc;
Index: sys/netinet6/in6_mcast.c
===================================================================
--- sys/netinet6/in6_mcast.c	(revision 195689)
+++ sys/netinet6/in6_mcast.c	(working copy)
@@ -66,9 +66,8 @@
 #include <netinet/in_pcb.h>
 #include <netinet/tcp_var.h>
 #include <netinet6/nd6.h>
-#include <netinet/vinet.h>
-#include <netinet6/vinet6.h>
 #include <netinet6/mld6_var.h>
+#include <netinet6/scope6_var.h>
 
 #ifndef KTR_MLD
 #define KTR_MLD KTR_INET6
@@ -1319,7 +1318,6 @@
 static int
 in6p_block_unblock_source(struct inpcb *inp, struct sockopt *sopt)
 {
-	INIT_VNET_NET(curvnet);
 	struct group_source_req		 gsr;
 	sockunion_t			*gsa, *ssa;
 	struct ifnet			*ifp;
@@ -1482,7 +1480,6 @@
 static struct ip6_moptions *
 in6p_findmoptions(struct inpcb *inp)
 {
-	INIT_VNET_INET6(curvnet);
 	struct ip6_moptions	 *imo;
 	struct in6_multi		**immp;
 	struct in6_mfilter	 *imfp;
@@ -1560,7 +1557,6 @@
 static int
 in6p_get_source_filters(struct inpcb *inp, struct sockopt *sopt)
 {
-	INIT_VNET_NET(curvnet);
 	struct __msfilterreq	 msfr;
 	sockunion_t		*gsa;
 	struct ifnet		*ifp;
@@ -1685,7 +1681,6 @@
 int
 ip6_getmoptions(struct inpcb *inp, struct sockopt *sopt)
 {
-	INIT_VNET_INET6(curvnet);
 	struct ip6_moptions	*im6o;
 	int			 error;
 	u_int			 optval;
@@ -1808,7 +1803,6 @@
 static int
 in6p_join_group(struct inpcb *inp, struct sockopt *sopt)
 {
-	INIT_VNET_NET(curvnet);
 	struct group_source_req		 gsr;
 	sockunion_t			*gsa, *ssa;
 	struct ifnet			*ifp;
@@ -2055,8 +2049,6 @@
 static int
 in6p_leave_group(struct inpcb *inp, struct sockopt *sopt)
 {
-	INIT_VNET_NET(curvnet);
-	INIT_VNET_INET6(curvnet);
 	struct ipv6_mreq		 mreq;
 	struct group_source_req		 gsr;
 	sockunion_t			*gsa, *ssa;
@@ -2292,7 +2284,6 @@
 static int
 in6p_set_multicast_if(struct inpcb *inp, struct sockopt *sopt)
 {
-	INIT_VNET_NET(curvnet);
 	struct ifnet		*ifp;
 	struct ip6_moptions	*imo;
 	u_int			 ifindex;
@@ -2326,7 +2317,6 @@
 static int
 in6p_set_source_filters(struct inpcb *inp, struct sockopt *sopt)
 {
-	INIT_VNET_NET(curvnet);
 	struct __msfilterreq	 msfr;
 	sockunion_t		*gsa;
 	struct ifnet		*ifp;
@@ -2507,7 +2497,6 @@
 int
 ip6_setmoptions(struct inpcb *inp, struct sockopt *sopt)
 {
-	INIT_VNET_INET6(curvnet);
 	struct ip6_moptions	*im6o;
 	int			 error;
 
@@ -2615,7 +2604,6 @@
 static int
 sysctl_ip6_mcast_filters(SYSCTL_HANDLER_ARGS)
 {
-	INIT_VNET_NET(curvnet);
 	struct in6_addr			 mcaddr;
 	struct in6_addr			 src;
 	struct ifnet			*ifp;
Index: sys/netinet6/route6.c
===================================================================
--- sys/netinet6/route6.c	(revision 195689)
+++ sys/netinet6/route6.c	(working copy)
@@ -51,7 +51,6 @@
 #include <netinet6/scope6_var.h>
 
 #include <netinet/icmp6.h>
-#include <netinet6/vinet6.h>
 
 /*
  * proto - is unused
@@ -60,7 +59,6 @@
 int
 route6_input(struct mbuf **mp, int *offp, int proto)
 {
-	INIT_VNET_INET6(curvnet);
 	struct ip6_hdr *ip6;
 	struct mbuf *m = *mp;
 	struct ip6_rthdr *rh;
Index: sys/netinet6/ip6_mroute.c
===================================================================
--- sys/netinet6/ip6_mroute.c	(revision 195689)
+++ sys/netinet6/ip6_mroute.c	(working copy)
@@ -113,7 +113,6 @@
 #include <netinet/in.h>
 #include <netinet/in_var.h>
 #include <netinet/icmp6.h>
-#include <netinet/vinet.h>
 #include <netinet/ip_encap.h>
 
 #include <netinet/ip6.h>
@@ -124,7 +123,6 @@
 #include <netinet6/ip6protosw.h>
 #include <netinet6/pim6.h>
 #include <netinet6/pim6_var.h>
-#include <netinet6/vinet6.h>
 
 static MALLOC_DEFINE(M_MRTABLE6, "mf6c", "multicast forwarding cache entry");
 
@@ -156,9 +154,8 @@
 };
 static int pim6_encapcheck(const struct mbuf *, int, int, void *);
 
-#ifdef VIMAGE_GLOBALS
-static int ip6_mrouter_ver;
-#endif
+static VNET_DEFINE(int, ip6_mrouter_ver);
+#define	V_ip6_mrouter_ver	VNET_GET(ip6_mrouter_ver)
 
 SYSCTL_DECL(_net_inet6);
 SYSCTL_DECL(_net_inet6_ip6);
@@ -216,9 +213,8 @@
 #define	MIF6_LOCK_DESTROY()	mtx_destroy(&mif6_mtx)
 
 #ifdef MRT6DEBUG
-#ifdef VIMAGE_GLOBALS
-static u_int mrt6debug;		/* debug level */
-#endif
+static VNET_DEFINE(u_int, mrt6debug);		/* debug level */
+#define	V_mrt6debug		VNET_GET(mrt6debug)
 #define DEBUG_MFC	0x02
 #define DEBUG_FORWARD	0x04
 #define DEBUG_EXPIRE	0x08
@@ -261,9 +257,8 @@
     &pim6stat, pim6stat,
     "PIM Statistics (struct pim6stat, netinet6/pim_var.h)");
 
-#ifdef VIMAGE_GLOBALS
-static int pim6;
-#endif
+static VNET_DEFINE(int, pim6);
+#define	V_pim6		VNET_GET(pim6)
 
 /*
  * Hash function for a source, group entry
@@ -347,9 +342,7 @@
 static void
 pim6_init(void)
 {
-	INIT_VNET_INET6(curvnet);
 
-	V_ip6_mrouter_ver = 0;
 #ifdef MRT6DEBUG
 	V_mrt6debug = 0;	/* debug level */
 #endif
@@ -361,7 +354,6 @@
 int
 X_ip6_mrouter_set(struct socket *so, struct sockopt *sopt)
 {
-	INIT_VNET_INET6(curvnet);
 	int error = 0;
 	int optval;
 	struct mif6ctl mifc;
@@ -430,7 +422,6 @@
 int
 X_ip6_mrouter_get(struct socket *so, struct sockopt *sopt)
 {
-	INIT_VNET_INET6(curvnet);
 	int error = 0;
 
 	if (so != V_ip6_mrouter)
@@ -528,7 +519,6 @@
 static int
 set_pim6(int *i)
 {
-	INIT_VNET_INET6(curvnet);
 	if ((*i != 1) && (*i != 0))
 		return (EINVAL);
 
@@ -543,7 +533,6 @@
 static int
 ip6_mrouter_init(struct socket *so, int v, int cmd)
 {
-	INIT_VNET_INET6(curvnet);
 
 	V_ip6_mrouter_ver = 0;
 
@@ -598,7 +587,6 @@
 int
 X_ip6_mrouter_done(void)
 {
-	INIT_VNET_INET6(curvnet);
 	mifi_t mifi;
 	int i;
 	struct mf6c *rt;
@@ -683,7 +671,6 @@
 static int
 add_m6if(struct mif6ctl *mifcp)
 {
-	INIT_VNET_NET(curvnet);
 	struct mif6 *mifp;
 	struct ifnet *ifp;
 	int error;
@@ -1100,7 +1087,6 @@
 int
 X_ip6_mforward(struct ip6_hdr *ip6, struct ifnet *ifp, struct mbuf *m)
 {
-	INIT_VNET_INET6(curvnet);
 	struct mf6c *rt;
 	struct mif6 *mifp;
 	struct mbuf *mm;
@@ -1425,7 +1411,6 @@
 static int
 ip6_mdq(struct mbuf *m, struct ifnet *ifp, struct mf6c *rt)
 {
-	INIT_VNET_INET6(curvnet);
 	struct ip6_hdr *ip6 = mtod(m, struct ip6_hdr *);
 	mifi_t mifi, iif;
 	struct mif6 *mifp;
@@ -1604,7 +1589,6 @@
 static void
 phyint_send(struct ip6_hdr *ip6, struct mif6 *mifp, struct mbuf *m)
 {
-	INIT_VNET_INET6(curvnet);
 	struct mbuf *mb_copy;
 	struct ifnet *ifp = mifp->m6_ifp;
 	int error = 0;
@@ -1714,7 +1698,6 @@
 static int
 register_send(struct ip6_hdr *ip6, struct mif6 *mif, struct mbuf *m)
 {
-	INIT_VNET_INET6(curvnet);
 	struct mbuf *mm;
 	int i, len = m->m_pkthdr.len;
 	static struct sockaddr_in6 sin6 = { sizeof(sin6), AF_INET6 };
@@ -1805,7 +1788,6 @@
 int
 pim6_input(struct mbuf **mp, int *offp, int proto)
 {
-	INIT_VNET_INET6(curvnet);
 	struct pim *pim; /* pointer to a pim struct */
 	struct ip6_hdr *ip6;
 	int pimlen;
@@ -2036,7 +2018,6 @@
 static int
 ip6_mroute_modevent(module_t mod, int type, void *unused)
 {
-	INIT_VNET_INET6(curvnet);
 
 	switch (type) {
 	case MOD_LOAD:
